| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
StalledEventMonitor Class Reference

Service that monitor the time taken by processing of single events using a separate thread. More...

`#include <src/component/StalledEventMonitor.h>`

Inheritance diagram for StalledEventMonitor:
[legend]
Collaboration diagram for StalledEventMonitor:
[legend]

## Public Member Functions
| StalledEventMonitor (const std::string &name, ISvcLocator *svcLoc)
| Constructor. More...
| ~StalledEventMonitor () override=default
| Destructor. More...
StatusCode | initialize () override
| Initialization of the service. More...
StatusCode | start () override
| Start the watchdog thread (before entering the event loop). More...
void | handle (const Incident &) override
| Notify the watchdog thread for a new event. More...
StatusCode | stop () override
| Stop the watchdog thread (after the event loop). More...
StatusCode | finalize () override
| Finalization of the service. More...
Public Member Functions inherited from extends< Service, IIncidentListener >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Attributes
Gaudi::Property< unsigned int > | m_eventTimeout
Gaudi::Property< int > | m_maxTimeoutCount
Gaudi::Property< bool > | m_stackTrace {this, "StackTrace", false, "Whether to print the stack-trace on timeout."}
std::unique_ptr< WatchdogThread > | m_watchdog
| Pointer to the watchdog thread that checks for the event timeout. More...
SmartIF< IIncidentSvc > | m_incidentSvc
| Pointer to the incident service. More...

## Additional Inherited Members
Public Types inherited from extends< Service, IIncidentListener >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Service that monitor the time taken by processing of single events using a separate thread.

See also
  WatchdogThread

Author
  Marco Clemencic

Date
  Apr 19, 2010

Definition at line 29 of file StalledEventMonitor.h.

## Constructor & Destructor Documentation

StalledEventMonitor::StalledEventMonitor | ( | const std::string & | name,
|  | ISvcLocator * | svcLoc
| ) |  |

Constructor.

Definition at line 84 of file StalledEventMonitor.cpp.

84 :
85 base_class(name, svcLoc) {
86
87 }
extends< Service, IIncidentListener >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14

StalledEventMonitor::~StalledEventMonitor | ( |  | ) |
| override default

Destructor.

## Member Function Documentation

StatusCode StalledEventMonitor::finalize | ( |  | ) |
| override

Finalization of the service.

Definition at line 138 of file StalledEventMonitor.cpp.

138 {
139 // destroy the watchdog thread (if any)
140 m_watchdog.reset();
141 // unregistering from the IncidentSvc
142 m_incidentSvc->removeListener(this, IncidentType::BeginEvent);
143 m_incidentSvc.reset();
144 return base_class::finalize();
145 }
StalledEventMonitor::m_watchdog
std::unique_ptr< WatchdogThread > m_watchdog
Pointer to the watchdog thread that checks for the event timeout.
Definition: StalledEventMonitor.h:62
StalledEventMonitor::m_incidentSvc
SmartIF< IIncidentSvc > m_incidentSvc
Pointer to the incident service.
Definition: StalledEventMonitor.h:65
std::unique_ptr::reset
T reset(T...args)
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:88
IIncidentSvc::removeListener
virtual void removeListener(IIncidentListener *lis, const std::string &type="")=0
Remove listener.

void StalledEventMonitor::handle | ( | const Incident & |  | ) |
| override

Notify the watchdog thread for a new event.

Definition at line 127 of file StalledEventMonitor.cpp.

127 {
128 if (m_watchdog) m_watchdog->ping();
129 }
StalledEventMonitor::m_watchdog
std::unique_ptr< WatchdogThread > m_watchdog
Pointer to the watchdog thread that checks for the event timeout.
Definition: StalledEventMonitor.h:62
WatchdogThread::ping
void ping()
Function to call to notify the watchdog thread that we are still alive.
Definition: WatchdogThread.h:44

StatusCode StalledEventMonitor::initialize | ( |  | ) |
| override

Initialization of the service.

Prepare the watchdog thread and configures it.

Definition at line 90 of file StalledEventMonitor.cpp.

90 {
91 StatusCode sc = base_class::initialize();
92 if (sc.isFailure()) return sc;
93
94
95 if (m_eventTimeout) {
96 // create the watchdog thread
97 m_watchdog.reset( new EventWatchdog(msgSvc(),
98 "EventWatchdog",
99 boost::posix_time::seconds(m_eventTimeout),
100 m_stackTrace,
101 m_maxTimeoutCount));
102
103 // register to the incident service
104 static const std::string serviceName = "IncidentSvc";
105 m_incidentSvc = serviceLocator()->service(serviceName);
106 if ( ! m_incidentSvc ) {
107 error() << "Cannot retrieve " << serviceName << endmsg;
108 return StatusCode::FAILURE;
109 }
110 debug() << "Register to the IncidentSvc" << endmsg;
111 m_incidentSvc->addListener(this, IncidentType::BeginEvent);
112 } else {
113 warning() << "StalledEventMonitor/" << name()
114 << " instantiated with 0 time-out: no monitoring performed" << endmsg;
115 }
116
117 return StatusCode::SUCCESS;
118 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
StatusCode::FAILURE
Definition: StatusCode.h:29
StalledEventMonitor::m_eventTimeout
Gaudi::Property< unsigned int > m_eventTimeout
Definition: StalledEventMonitor.h:55
StalledEventMonitor::m_watchdog
std::unique_ptr< WatchdogThread > m_watchdog
Pointer to the watchdog thread that checks for the event timeout.
Definition: StalledEventMonitor.h:62
StalledEventMonitor::m_stackTrace
Gaudi::Property< bool > m_stackTrace
Definition: StalledEventMonitor.h:59
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:84
std::string
STL class.
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:78
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
StalledEventMonitor::m_incidentSvc
SmartIF< IIncidentSvc > m_incidentSvc
Pointer to the incident service.
Definition: StalledEventMonitor.h:65
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:120
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
std::unique_ptr::reset
T reset(T...args)
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
IIncidentSvc::addListener
virtual void addListener(IIncidentListener *lis, const std::string &type="", long priority=0, bool rethrow=false, bool singleShot=false)=0
Add listener.
CommonMessagingBase::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
The standard message service.
Definition: CommonMessaging.h:70
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:292
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
StalledEventMonitor::m_maxTimeoutCount
Gaudi::Property< int > m_maxTimeoutCount
Definition: StalledEventMonitor.h:57

StatusCode StalledEventMonitor::start | ( |  | ) |
| override

Start the watchdog thread (before entering the event loop).

Definition at line 121 of file StalledEventMonitor.cpp.

121 {
122 if (m_watchdog) m_watchdog->start();
123 return StatusCode::SUCCESS;
124 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
WatchdogThread::start
void start()
Start the watchdog thread.
Definition: WatchdogThread.cpp:24
StalledEventMonitor::m_watchdog
std::unique_ptr< WatchdogThread > m_watchdog
Pointer to the watchdog thread that checks for the event timeout.
Definition: StalledEventMonitor.h:62

StatusCode StalledEventMonitor::stop | ( |  | ) |
| override

Stop the watchdog thread (after the event loop).

Definition at line 132 of file StalledEventMonitor.cpp.

132 {
133 if (m_watchdog) m_watchdog->stop();
134 return StatusCode::SUCCESS;
135 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
StalledEventMonitor::m_watchdog
std::unique_ptr< WatchdogThread > m_watchdog
Pointer to the watchdog thread that checks for the event timeout.
Definition: StalledEventMonitor.h:62
WatchdogThread::stop
void stop()
Signal the watchdog thread to stop and wait for it.
Definition: WatchdogThread.cpp:36

## Member Data Documentation

Gaudi::Property<unsigned int> StalledEventMonitor::m_eventTimeout
| private

Initial value:
{
this, "EventTimeout", 600, "Number of seconds allowed to process a single event (0 to disable the check)."}

Definition at line 55 of file StalledEventMonitor.h.

SmartIF<IIncidentSvc> StalledEventMonitor::m_incidentSvc
| private

Pointer to the incident service.

Definition at line 65 of file StalledEventMonitor.h.

Gaudi::Property<int> StalledEventMonitor::m_maxTimeoutCount
| private

Initial value:
{this, "MaxTimeoutCount", 0,
"Number timeouts before aborting the execution (0 means never abort)."}

Definition at line 57 of file StalledEventMonitor.h.

Gaudi::Property<bool> StalledEventMonitor::m_stackTrace {this, "StackTrace", false, "Whether to print the stack-trace on timeout."}
| private

Definition at line 59 of file StalledEventMonitor.h.

std::unique_ptr<WatchdogThread> StalledEventMonitor::m_watchdog
| private

Pointer to the watchdog thread that checks for the event timeout.

Definition at line 62 of file StalledEventMonitor.h.

The documentation for this class was generated from the following files:

- GaudiUtils/src/component/StalledEventMonitor.h
- GaudiUtils/src/component/StalledEventMonitor.cpp